﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;
using System.Diagnostics;
using Infragistics.Win.Printing;

namespace UltraChartColumnChartLegendCustom
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraPrintPreviewDialog1 = new Infragistics.Win.Printing.UltraPrintPreviewDialog(this.components);
            ultraPrintPreviewDialog1.Name = "preview";
            ultraPrintPreviewDialog1.PreviewSettings.ZoomMode = Infragistics.Win.Printing.ZoomMode.WholePage;
            ultraPrintPreviewDialog1.ThumbnailAreaVisible = false;


            DataTable dt = new DataTable();
            dt.Columns.Add("Label", typeof(String));
            dt.Columns.Add("Dollars", typeof(Double));
            dt.Columns.Add("Price", typeof(Double));
            dt.Rows.Add("Sep", 1200000, 4.1);
            dt.Rows.Add("Oct", 1000000, 4.1);
            dt.Rows.Add("Nov", 1400000, 3.5);
            dt.Rows.Add("Dec", 4601000, 3.0);
            dt.Rows.Add("Jan", 1500000, 3.5);
            dt.Rows.Add("Feb", 1600000, 3.5);
            dt.Rows.Add("Mar", 2200000, 3.25);


            ultraChart1.ChartType = ChartType.Composite;
            ultraChart1.BackColor = Color.Black;
            ultraChart1.Data.ZeroAligned = true;
            ultraChart1.TitleTop.Text = "Sales to Price Analysis";
            ultraChart1.TitleTop.FontColor = Color.Yellow;
            ultraChart1.TitleTop.Font = new Font("Arial", 14.0F);
            ultraChart1.TitleTop.HorizontalAlign = StringAlignment.Center;


            // Create the Chart Area
            ChartArea area = new ChartArea();
            area.BoundsMeasureType = MeasureType.Percentage;
            area.Bounds = new Rectangle(25, 10, 74, 90);
            area.Border.Thickness = 0;
            AxisItem xAxis = new AxisItem();
            AxisItem x2Axis = new AxisItem();
            AxisItem yAxis = new AxisItem();
            AxisItem y2Axis = new AxisItem();

            ChartLayerAppearance ColumnLayer = new ChartLayerAppearance();
            ChartLayerAppearance LineLayer = new ChartLayerAppearance();

            NumericSeries columnSeries = new NumericSeries();
            ultraChart1.Series.Add(columnSeries);
            NumericSeries lineSeries = new NumericSeries();
            xAxis.OrientationType = AxisNumber.X_Axis;

            //xAxis.Extent = 60
            xAxis.DataType = AxisDataType.String;
            xAxis.SetLabelAxisType = SetLabelAxisType.GroupBySeries;
            xAxis.LineColor = Color.White;
            xAxis.Labels.FontColor = Color.White;
            xAxis.Labels.ItemFormatString = "<ITEM_LABEL>";
            xAxis.Labels.Layout.Behavior = AxisLabelLayoutBehaviors.Auto;
            xAxis.Labels.VerticalAlign = StringAlignment.Far;
            xAxis.Labels.HorizontalAlign = StringAlignment.Near;
            xAxis.Labels.Orientation = TextOrientation.Custom;
            xAxis.Labels.OrientationAngle = 45;
            xAxis.MajorGridLines.Visible = false;
            x2Axis.OrientationType = AxisNumber.X_Axis;

            //x2Axis.Extent = 50
            x2Axis.DataType = AxisDataType.String;
            x2Axis.LineColor = Color.Transparent;
            x2Axis.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            yAxis.OrientationType = AxisNumber.Y_Axis;
            yAxis.Extent = 60;
            yAxis.TickmarkStyle = AxisTickStyle.Smart;
            yAxis.DataType = AxisDataType.Numeric;
            yAxis.LineColor = Color.White;
            yAxis.Labels.FontColor = Color.White;
            yAxis.Labels.ItemFormatString = "<DATA_VALUE:$ ###,###,##0.# ->";
            y2Axis.OrientationType = AxisNumber.Y2_Axis;
            y2Axis.Extent = 50;
            y2Axis.TickmarkStyle = AxisTickStyle.Smart;
            y2Axis.MajorGridLines.Visible = false;
            y2Axis.DataType = AxisDataType.Numeric;
            y2Axis.LineColor = Color.White;
            y2Axis.Labels.FontColor = Color.White;
            y2Axis.Labels.ItemFormatString = "<DATA_VALUE:- #0.00>";
            columnSeries.Data.DataSource = dt;
            columnSeries.Data.LabelColumn = "Label";
            columnSeries.Data.ValueColumn = "Dollars";
            columnSeries.Label = "Dollars";
            //columnSeries.PEs.Add(new PaintElement(Color.SteelBlue));
            ColumnLayer.ChartType = ChartType.ColumnChart;
            ColumnLayer.Series.Add(columnSeries);
            ColumnLayer.ChartArea = area;
            ColumnLayer.AxisX = xAxis;
            ColumnLayer.AxisY = yAxis;


            ColumnChartAppearance columnApp = new ColumnChartAppearance();//  ColumnLayer.ChartTypeAppearance, ColumnChartAppearance); 
            columnApp.ColumnSpacing = 1;
            lineSeries.Data.DataSource = dt;
            lineSeries.Data.LabelColumn = "Label";
            lineSeries.Data.ValueColumn = "Price";
            lineSeries.PEs.Add(new PaintElement(Color.White));
            lineSeries.Label = "Price";
            LineLayer.ChartType = ChartType.LineChart;
            LineLayer.Series.Add(lineSeries);
            LineLayer.ChartArea = area;
            LineLayer.AxisX = x2Axis;
            LineLayer.AxisY = y2Axis;
            area.Axes.Add(xAxis);
            area.Axes.Add(x2Axis);
            area.Axes.Add(yAxis);
            area.Axes.Add(y2Axis);
            ultraChart1.CompositeChart.ChartAreas.Add(area);
            ultraChart1.CompositeChart.ChartLayers.Add(ColumnLayer);
            ultraChart1.CompositeChart.ChartLayers.Add(LineLayer);
            ultraChart1.CompositeChart.Series.Add(columnSeries);
            ultraChart1.CompositeChart.Series.Add(lineSeries);


            BoxAnnotation AxisYLabel = new BoxAnnotation();
            AxisYLabel.Text = "Dollars";
            AxisYLabel.Border.Color = Color.Transparent;
            AxisYLabel.FillColor = ultraChart1.BackColor;
            AxisYLabel.TextStyle.FontColor = Color.White;
            AxisYLabel.Location.Type = LocationType.Percentage;
            AxisYLabel.Location.LocationX = area.Bounds.X + 2;
            AxisYLabel.Location.LocationY = area.Bounds.Y - 2;
            ultraChart1.Annotations.Annotations.Add(AxisYLabel);


            BoxAnnotation AxisY2Label = new BoxAnnotation();
            AxisY2Label.Text = "Price";
            AxisY2Label.Width = -1;
            AxisY2Label.TextStyle.HorizontalAlign = StringAlignment.Far;
            AxisY2Label.Border.Color = Color.Transparent;
            AxisY2Label.FillColor = ultraChart1.BackColor;
            AxisY2Label.TextStyle.FontColor = Color.White;
            AxisY2Label.Location.Type = LocationType.Percentage;
            AxisY2Label.Location.LocationX = (area.Bounds.X + area.Bounds.Width) - 4;
            AxisY2Label.Location.LocationY = area.Bounds.Y - 2;
            ultraChart1.Annotations.Annotations.Add(AxisY2Label);
            ultraChart1.Legend.DataAssociation = ChartTypeData.SplitData;


            // Add a Legend
            CompositeLegend m_ChartLegend = new CompositeLegend();

            ColumnLayer.LegendItem = LegendItemType.Series;
            LineLayer.LegendItem = LegendItemType.Series;
            m_ChartLegend.ChartLayers.Add(ColumnLayer);
            m_ChartLegend.ChartLayers.Add(LineLayer);
            m_ChartLegend.BoundsMeasureType = MeasureType.Percentage;
            m_ChartLegend.Bounds = new Rectangle(1, 10, 18, 40);
            area.BoundsMeasureType = MeasureType.Percentage;
            area.Bounds = new Rectangle(25, 10, 74, 90);
            m_ChartLegend.PE.ElementType = PaintElementType.Gradient;
            m_ChartLegend.PE.FillGradientStyle = GradientStyle.Circular;
            m_ChartLegend.PE.Fill = Color.Yellow;
            m_ChartLegend.PE.FillStopColor = Color.Orange;
            m_ChartLegend.Border.CornerRadius = 10;
            m_ChartLegend.Border.Thickness = 0;
            m_ChartLegend.LabelStyle.FontSizeBestFit = true;
            ultraChart1.CompositeChart.Legends.Add(m_ChartLegend);



            Color[] initColor = new Color[] { Color.Red, Color.Gold, Color.LightSkyBlue, Color.Orange, Color.Olive, Color.Pink, Color.Snow };
            this.ultraChart1.ColorModel.CustomPalette = initColor;

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            Report report = new Report();
            ISection section = report.AddSection();
            section.PageOrientation = PageOrientation.Landscape;
            ICanvas canvas = section.AddCanvas();
            canvas.Width = new FixedWidth(1200);
            canvas.Height = new FixedHeight(1200);
            Graphics gr = canvas.CreateGraphics();
            ultraChart1.RenderPdfFriendlyGraphics(gr);

            report.Publish("..\\..\\Test.pdf", FileFormat.PDF);
            Process.Start("..\\..\\Test.pdf");
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            MyControl myCustomControl = new MyControl();
            myCustomControl.Document = ultraChart1.PrintDocument;
            myCustomControl.Show();
        }


    }
}
